package com.googlecode.etlunit.module_mojo;

import org.apache.commons.io.IOUtils;

import java.io.IOException;
import java.io.StringReader;
import java.net.URL;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;
import java.util.Properties;

public class ModuleVersions
{
	public static List<ModuleVersion> getAvailableVersions()
	{
		List<ModuleVersion> mvlist = new ArrayList<ModuleVersion>();

		try
		{
			Enumeration<URL> props = ModuleVersions.class.getClassLoader().getResources("/META-INF/etlunit-module");

			while (props.hasMoreElements())
			{
				URL url = props.nextElement();

				String propString = IOUtils.toString(url);

				Properties prop = new Properties();

				prop.load(new StringReader(propString));

				String propertyFile = prop.getProperty("etlunit-module-propertes");

				URL modProps = ModuleVersions.class.getClassLoader().getResource(propertyFile);

				propString = IOUtils.toString(modProps);

				prop = new Properties();

				prop.load(new StringReader(propString));

				ModuleVersion mv = new ModuleVersion();

				mv.setGitBranch(prop.getProperty("git.branch"));
				mv.setGitBranchClean(prop.getProperty("git.branch.clean"));
				mv.setGitBranchVersion(prop.getProperty("git.branch.version"));
				mv.setMavenProjectArtifactId(prop.getProperty("maven.project.artifactId"));
				mv.setMavenProjectGroupId(prop.getProperty("maven.project.groupId"));
				mv.setMavenProjectVersion(prop.getProperty("maven.project.version"));

				mvlist.add(mv);
			}
		}
		catch (IOException e)
		{
			throw new RuntimeException(e);
		}

		return mvlist;
	}
}